<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parser.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parser.hh</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parser.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 1997 Shigeru Chiba</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="comment">//</span></span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#ifndef Synopsis_Parser_hh_</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line">#define Synopsis_Parser_hh_</span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;Synopsis/PTree.hh&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;Synopsis/SymbolFactory.hh&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">#include &lt;vector&gt;</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">{</span>
<a id="line17"></a><span class="lineno"> 17</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">class Lexer;</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">struct Token;</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="comment">//. C++ Parser</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="comment">//.</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="comment">//. This parser is a LL(k) parser with ad hoc rules such as</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="comment">//. backtracking.</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="comment">//.</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="comment">//. &lt;name&gt;() is the grammer rule for a non-terminal &lt;name&gt;.</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="comment">//. opt_&lt;name&gt;() is the grammer rule for an optional non-terminal &lt;name&gt;.</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="comment">//. is_&lt;name&gt;() looks ahead and returns true if the next symbol is &lt;name&gt;.</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="keyword">class</span> <a href="../../Scopes/Synopsis/Parser.html" title="class Synopsis::Parser">Parser</a></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">{</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">  <span class="comment">//. RuleSet defines non-standard optional rules that can be chosen at runtime.</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">  <span class="keyword">enum</span> <a href="../../Scopes/Synopsis/Parser.html#RuleSet" title="enum Synopsis::Parser::RuleSet">RuleSet</a> { <a href="../../Scopes/Synopsis/Parser.html#CXX" title="enumerator Synopsis::Parser::CXX">CXX</a> = 0x01, <a href="../../Scopes/Synopsis/Parser.html#GCC" title="enumerator Synopsis::Parser::GCC">GCC</a> = 0x02, <a href="../../Scopes/Synopsis/Parser.html#MSVC" title="enumerator Synopsis::Parser::MSVC">MSVC</a> = 0x04};</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">  <span class="comment">//. Error is used to cache parse errors encountered during the execution</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="comment">  //. of the parse method.</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">  <span class="keyword">class</span> <a href="../../Scopes/Synopsis/Parser/Error.html" title="class Synopsis::Parser::Error">Error</a></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  {</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  <span class="keyword">public</span>:</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">    virtual <a href="../../Scopes/Synopsis/Parser/Error.html#_tError_l_r" title="member function Synopsis::Parser::Error::~Error()">~Error</a>() {}</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">    virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::Parser::Error::write(std::ostream&amp;)const">write</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;) const = 0;</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">  };</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::vector">vector</a>&lt;<a href="../../Scopes/Synopsis/Parser/Error.html" title="class Synopsis::Parser::Error">Error</a> *&gt; <a href="../../Scopes/Synopsis/Parser.html#ErrorList" title="typedef Synopsis::Parser::ErrorList">ErrorList</a>;</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">  <a href="../../Scopes/Synopsis/Parser.html#Parser_lLexer_A_cSymbolFactory_A_cint_r" title="member function Synopsis::Parser::Parser(Lexer&amp;,SymbolFactory&amp;,int)">Parser</a>(<a href="../../Scopes/Synopsis/Lexer.html" title="class Synopsis::Lexer">Lexer</a> &amp;lexer, <a href="../../Scopes/Synopsis/SymbolFactory.html" title="class Synopsis::SymbolFactory">SymbolFactory</a> &amp;symbols, <span class="keyword">int</span> ruleset = CXX|GCC);</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">  <a href="../../Scopes/Synopsis/Parser.html#_tParser_l_r" title="member function Synopsis::Parser::~Parser()">~Parser</a>();</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">  <a href="../../Scopes/Synopsis/Parser.html#ErrorList" title="typedef Synopsis::Parser::ErrorList">ErrorList const</a> &amp;<a href="../../Scopes/Synopsis/Parser.html#errors_l_rconst" title="member function Synopsis::Parser::errors()const">errors</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Parser.html#my_errors" title="data member Synopsis::Parser::my_errors">my_errors</a>;}</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">  <span class="comment">//. Return the origin of the given pointer</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="comment">  //. (filename and line number)</span></span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  <span class="keyword">unsigned long</span> <a href="" title="member function Synopsis::Parser::origin(const char*,std::string&amp;)const">origin</a>(<span class="keyword">const</span> <span class="keyword">char</span> *, <a href="" title="typedef std::string">std::string</a> &amp;) const;</span>
<a id="line53"></a><span class="lineno"> 53</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *<a href="../../Scopes/Synopsis/Parser.html#parse_l_r" title="member function Synopsis::Parser::parse()">parse</a>();</span>
<a id="line55"></a><span class="lineno"> 55</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">  <span class="keyword">enum</span> <a href="../../Scopes/Synopsis/Parser.html#DeclKind" title="enum Synopsis::Parser::DeclKind">DeclKind</a> { <a href="../../Scopes/Synopsis/Parser.html#kDeclarator" title="enumerator Synopsis::Parser::kDeclarator">kDeclarator</a>, <a href="../../Scopes/Synopsis/Parser.html#kArgDeclarator" title="enumerator Synopsis::Parser::kArgDeclarator">kArgDeclarator</a>, <a href="../../Scopes/Synopsis/Parser.html#kCastDeclarator" title="enumerator Synopsis::Parser::kCastDeclarator">kCastDeclarator</a> };</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">  <span class="keyword">enum</span> <a href="../../Scopes/Synopsis/Parser.html#TemplateDeclKind" title="enum Synopsis::Parser::TemplateDeclKind">TemplateDeclKind</a> { <a href="../../Scopes/Synopsis/Parser.html#tdk_unknown" title="enumerator Synopsis::Parser::tdk_unknown">tdk_unknown</a>, <a href="../../Scopes/Synopsis/Parser.html#tdk_decl" title="enumerator Synopsis::Parser::tdk_decl">tdk_decl</a>, <a href="../../Scopes/Synopsis/Parser.html#tdk_instantiation" title="enumerator Synopsis::Parser::tdk_instantiation">tdk_instantiation</a>, </span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">			  <a href="../../Scopes/Synopsis/Parser.html#tdk_specialization" title="enumerator Synopsis::Parser::tdk_specialization">tdk_specialization</a>, <a href="../../Scopes/Synopsis/Parser.html#num_tdks" title="enumerator Synopsis::Parser::num_tdks">num_tdks</a> };</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">  struct ScopeGuard;</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">  friend struct ScopeGuard;</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">  <span class="comment">//. A StatusGuard manages a tentative parse.</span></span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="comment">  //. All actions invoked after its instantiation</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line"><span class="comment">  //. will be rolled back in the destructor unless</span></span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="comment">  //. 'commit' has been called before.</span></span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">  <span class="keyword">class</span> <a href="../../Scopes/Synopsis/Parser/StatusGuard.html" title="class Synopsis::Parser::StatusGuard">StatusGuard</a></span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">  {</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">  <span class="keyword">public</span>:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">    <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#StatusGuard_lParser_A_r" title="member function Synopsis::Parser::StatusGuard::StatusGuard(Parser&amp;)">StatusGuard</a>(<a href="../../Scopes/Synopsis/Parser.html" title="class Synopsis::Parser">Parser</a> &amp;);</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#_tStatusGuard_l_r" title="member function Synopsis::Parser::StatusGuard::~StatusGuard()">~StatusGuard</a>();</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#commit_l_r" title="member function Synopsis::Parser::StatusGuard::commit()">commit</a>() { <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_committed" title="data member Synopsis::Parser::StatusGuard::my_committed">my_committed</a> = true;}</span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">  <span class="keyword">private</span>:</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <a href="../../Scopes/Synopsis/Lexer.html" title="class Synopsis::Lexer">Lexer</a> &amp;                      <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_lexer" title="data member Synopsis::Parser::StatusGuard::my_lexer">my_lexer</a>;</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <span class="keyword">char const</span> *                 <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_token_mark" title="data member Synopsis::Parser::StatusGuard::my_token_mark">my_token_mark</a>;</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <a href="../../Scopes/Synopsis/Parser.html#ErrorList" title="typedef Synopsis::Parser::ErrorList">ErrorList</a>                    <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_errors" title="data member Synopsis::Parser::StatusGuard::my_errors">my_errors</a>;</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    Parser::ErrorList::size_type <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_error_mark" title="data member Synopsis::Parser::StatusGuard::my_error_mark">my_error_mark</a>;</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <span class="keyword">bool</span>                         <a href="../../Scopes/Synopsis/Parser/StatusGuard.html#my_committed" title="data member Synopsis::Parser::StatusGuard::my_committed">my_committed</a>;</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">  };</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">  friend class StatusGuard;</span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#mark_error_l_r" title="member function Synopsis::Parser::mark_error()">mark_error</a>();</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">  template &lt;typename T&gt;</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#declare_lT_S_r" title="member function template Synopsis::Parser::declare(T*)">declare</a>(T *);</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Parser.html#show_message_head_lconst.char_S_r" title="member function Synopsis::Parser::show_message_head(const char*)">show_message_head</a>(<span class="keyword">const</span> <span class="keyword">char</span>*);</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::definition(PTree::Node*&amp;)">definition</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::null_declaration(PTree::Node*&amp;)">null_declaration</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::typedef_(PTree::Typedef*&amp;)">typedef_</a>(<a href="../../Scopes/Synopsis/PTree/Typedef.html" title="class Synopsis::PTree::Typedef">PTree::Typedef</a> *&amp;);</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::type_specifier(PTree::Node*&amp;,bool,PTree::Encoding&amp;)">type_specifier</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <span class="keyword">bool</span>, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#is_type_specifier_l_r" title="member function Synopsis::Parser::is_type_specifier()">is_type_specifier</a>();</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::metaclass_decl(PTree::Node*&amp;)">metaclass_decl</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::meta_arguments(PTree::Node*&amp;)">meta_arguments</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::linkage_spec(PTree::Node*&amp;)">linkage_spec</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::namespace_spec(PTree::NamespaceSpec*&amp;)">namespace_spec</a>(<a href="../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec</a> *&amp;);</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::namespace_alias(PTree::NamespaceAlias*&amp;)">namespace_alias</a>(<a href="../../Scopes/Synopsis/PTree/NamespaceAlias.html" title="class Synopsis::PTree::NamespaceAlias">PTree::NamespaceAlias</a> *&amp;);</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::using_directive(PTree::UsingDirective*&amp;)">using_directive</a>(<a href="../../Scopes/Synopsis/PTree/UsingDirective.html" title="class Synopsis::PTree::UsingDirective">PTree::UsingDirective</a> *&amp;);</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::using_declaration(PTree::UsingDeclaration*&amp;)">using_declaration</a>(<a href="../../Scopes/Synopsis/PTree/UsingDeclaration.html" title="class Synopsis::PTree::UsingDeclaration">PTree::UsingDeclaration</a> *&amp;);</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::linkage_body(PTree::Node*&amp;)">linkage_body</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::template_decl(PTree::Node*&amp;)">template_decl</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::template_decl2(PTree::TemplateDecl*&amp;,TemplateDeclKind&amp;)">template_decl2</a>(<a href="../../Scopes/Synopsis/PTree/TemplateDecl.html" title="class Synopsis::PTree::TemplateDecl">PTree::TemplateDecl</a> *&amp;, <a href="../../Scopes/Synopsis/Parser.html#TemplateDeclKind" title="enum Synopsis::Parser::TemplateDeclKind">TemplateDeclKind</a> &amp;kind);</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">  <span class="comment">//. template-parameter-list:</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line"><span class="comment">  //.</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line"><span class="comment">  //. - template-parameter</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line"><span class="comment">  //. - template-parameter-list `,` template-parameter</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::template_parameter_list(PTree::List*&amp;)">template_parameter_list</a>(<a href="../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List</a> *&amp;);</span>
<a id="line111"></a><span class="lineno">111</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">  <span class="comment">//. template-parameter:</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line"><span class="comment">  //.</span></span>
<a id="line114"></a><span class="lineno">114</span><span class="line"><span class="comment">  //. - type-parameter</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line"><span class="comment">  //. - parameter-declaration</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::template_parameter(PTree::Node*&amp;)">template_parameter</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">  <span class="comment">//. type-parameter:</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line"><span class="comment">  //.</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line"><span class="comment">  //. - class identifier [opt]</span></span>
<a id="line121"></a><span class="lineno">121</span><span class="line"><span class="comment">  //. - class identifier [opt] `=` type-id</span></span>
<a id="line122"></a><span class="lineno">122</span><span class="line"><span class="comment">  //. - typename identifier [opt]</span></span>
<a id="line123"></a><span class="lineno">123</span><span class="line"><span class="comment">  //. - typename identifier [opt] `=` type-id</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line"><span class="comment">  //. - template  `&lt;` template-parameter-list `&gt;` class identifier [opt]</span></span>
<a id="line125"></a><span class="lineno">125</span><span class="line"><span class="comment">  //. - template  `&lt;` template-parameter-list `&gt;` class identifier [opt] `=` id-expression</span></span>
<a id="line126"></a><span class="lineno">126</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::type_parameter(PTree::Node*&amp;)">type_parameter</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">  </span>
<a id="line128"></a><span class="lineno">128</span><span class="line">  <span class="comment">//. GNU extension:</span></span>
<a id="line129"></a><span class="lineno">129</span><span class="line"><span class="comment">  //. extern-template-decl:</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="comment">  //.</span></span>
<a id="line131"></a><span class="lineno">131</span><span class="line"><span class="comment">  //. - extern template declaration</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::extern_template_decl(PTree::Node*&amp;)">extern_template_decl</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::declaration(PTree::Declaration*&amp;)">declaration</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;);</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::integral_declaration(PTree::Declaration*&amp;,PTree::Encoding&amp;,PTree::Node*,PTree::Node*,PTree::Node*)">integral_declaration</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *);</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::const_declaration(PTree::Declaration*&amp;,PTree::Encoding&amp;,PTree::Node*,PTree::Node*)">const_declaration</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *);</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::other_declaration(PTree::Declaration*&amp;,PTree::Encoding&amp;,PTree::Node*,PTree::Node*,PTree::Node*)">other_declaration</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *);</span>
<a id="line138"></a><span class="lineno">138</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">  <span class="comment">//. condition:</span></span>
<a id="line140"></a><span class="lineno">140</span><span class="line"><span class="comment">  //.</span></span>
<a id="line141"></a><span class="lineno">141</span><span class="line"><span class="comment">  //. - expression</span></span>
<a id="line142"></a><span class="lineno">142</span><span class="line"><span class="comment">  //. - type-specifier-seq declarator `=` assignment-expression</span></span>
<a id="line143"></a><span class="lineno">143</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::condition(PTree::Node*&amp;)">condition</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#is_constructor_decl_l_r" title="member function Synopsis::Parser::is_constructor_decl()">is_constructor_decl</a>();</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#is_ptr_to_member_lint_r" title="member function Synopsis::Parser::is_ptr_to_member(int)">is_ptr_to_member</a>(<span class="keyword">int</span>);</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::opt_member_spec(PTree::Node*&amp;)">opt_member_spec</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line148"></a><span class="lineno">148</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">  <span class="comment">//. storage-spec:</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line"><span class="comment">  //.</span></span>
<a id="line151"></a><span class="lineno">151</span><span class="line"><span class="comment">  //. - empty</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line"><span class="comment">  //. - static</span></span>
<a id="line153"></a><span class="lineno">153</span><span class="line"><span class="comment">  //. - extern</span></span>
<a id="line154"></a><span class="lineno">154</span><span class="line"><span class="comment">  //. - auto</span></span>
<a id="line155"></a><span class="lineno">155</span><span class="line"><span class="comment">  //. - register</span></span>
<a id="line156"></a><span class="lineno">156</span><span class="line"><span class="comment">  //. - mutable</span></span>
<a id="line157"></a><span class="lineno">157</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::opt_storage_spec(PTree::Node*&amp;)">opt_storage_spec</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">  <span class="comment">//. cv-qualifier:</span></span>
<a id="line160"></a><span class="lineno">160</span><span class="line"><span class="comment">  //.</span></span>
<a id="line161"></a><span class="lineno">161</span><span class="line"><span class="comment">  //. - empty</span></span>
<a id="line162"></a><span class="lineno">162</span><span class="line"><span class="comment">  //. - const</span></span>
<a id="line163"></a><span class="lineno">163</span><span class="line"><span class="comment">  //. - volatile</span></span>
<a id="line164"></a><span class="lineno">164</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::opt_cv_qualifier(PTree::Node*&amp;)">opt_cv_qualifier</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::opt_integral_type_or_class_spec(PTree::Node*&amp;,PTree::Encoding&amp;)">opt_integral_type_or_class_spec</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::constructor_decl(PTree::Node*&amp;,PTree::Encoding&amp;)">constructor_decl</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::opt_throw_decl(PTree::Node*&amp;)">opt_throw_decl</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">  </span>
<a id="line169"></a><span class="lineno">169</span><span class="line">  <span class="comment">//. [gram.dcl.decl]</span></span>
<a id="line170"></a><span class="lineno">170</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::init_declarator_list(PTree::Node*&amp;,PTree::Encoding&amp;,bool,bool)">init_declarator_list</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <span class="keyword">bool</span>, <span class="keyword">bool</span> = false);</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::init_declarator(PTree::Node*&amp;,PTree::Encoding&amp;,bool,bool)">init_declarator</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <span class="keyword">bool</span>, <span class="keyword">bool</span>);</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::declarator(PTree::Node*&amp;,DeclKind,bool,PTree::Encoding&amp;,PTree::Encoding&amp;,bool,bool)">declarator</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/Parser.html#DeclKind" title="enum Synopsis::Parser::DeclKind">DeclKind</a>, <span class="keyword">bool</span>,</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">		  <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <span class="keyword">bool</span>,</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">		  <span class="keyword">bool</span> = false);</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::declarator2(PTree::Node*&amp;,DeclKind,bool,PTree::Encoding&amp;,PTree::Encoding&amp;,bool,bool,PTree::Node**)">declarator2</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/Parser.html#DeclKind" title="enum Synopsis::Parser::DeclKind">DeclKind</a>, <span class="keyword">bool</span>,</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">		   <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <span class="keyword">bool</span>,</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">		   <span class="keyword">bool</span>, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> **);</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::opt_ptr_operator(PTree::Node*&amp;,PTree::Encoding&amp;)">opt_ptr_operator</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::member_initializers(PTree::Node*&amp;)">member_initializers</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::member_init(PTree::Node*&amp;)">member_init</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">  </span>
<a id="line182"></a><span class="lineno">182</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::name(PTree::Node*&amp;,PTree::Encoding&amp;)">name</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::operator_name(PTree::Node*&amp;,PTree::Encoding&amp;)">operator_name</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::cast_operator_name(PTree::Node*&amp;,PTree::Encoding&amp;)">cast_operator_name</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::ptr_to_member(PTree::Node*&amp;,PTree::Encoding&amp;)">ptr_to_member</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::template_args(PTree::Node*&amp;,PTree::Encoding&amp;)">template_args</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">  </span>
<a id="line188"></a><span class="lineno">188</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::parameter_declaration_list_or_init(PTree::Node*&amp;,bool&amp;,PTree::Encoding&amp;,bool)">parameter_declaration_list_or_init</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <span class="keyword">bool</span>&amp;,</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">					  <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <span class="keyword">bool</span>);</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::parameter_declaration_list(PTree::Node*&amp;,PTree::Encoding&amp;)">parameter_declaration_list</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line191"></a><span class="lineno">191</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">  <span class="comment">//. parameter-declaration:</span></span>
<a id="line193"></a><span class="lineno">193</span><span class="line"><span class="comment">  //.</span></span>
<a id="line194"></a><span class="lineno">194</span><span class="line"><span class="comment">  //. - decl-specifier-seq declarator</span></span>
<a id="line195"></a><span class="lineno">195</span><span class="line"><span class="comment">  //. - decl-specifier-seq declarator `=` assignment-expression</span></span>
<a id="line196"></a><span class="lineno">196</span><span class="line"><span class="comment">  //. - decl-specifier-seq abstract-declarator [opt]</span></span>
<a id="line197"></a><span class="lineno">197</span><span class="line"><span class="comment">  //. - decl-specifier-seq abstract-declarator [opt] `=` assignment-expression</span></span>
<a id="line198"></a><span class="lineno">198</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::parameter_declaration(PTree::ParameterDeclaration*&amp;,PTree::Encoding&amp;)">parameter_declaration</a>(<a href="../../Scopes/Synopsis/PTree/ParameterDeclaration.html" title="class Synopsis::PTree::ParameterDeclaration">PTree::ParameterDeclaration</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">  </span>
<a id="line200"></a><span class="lineno">200</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::function_arguments(PTree::Node*&amp;)">function_arguments</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::designation(PTree::Node*&amp;)">designation</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::initialize_expr(PTree::Node*&amp;)">initialize_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">  </span>
<a id="line204"></a><span class="lineno">204</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::enum_spec(PTree::EnumSpec*&amp;,PTree::Encoding&amp;)">enum_spec</a>(<a href="../../Scopes/Synopsis/PTree/EnumSpec.html" title="class Synopsis::PTree::EnumSpec">PTree::EnumSpec</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::enum_body(PTree::Node*&amp;)">enum_body</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::class_spec(PTree::ClassSpec*&amp;,PTree::Encoding&amp;)">class_spec</a>(<a href="../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">  <span class="comment">//. base-clause:</span></span>
<a id="line209"></a><span class="lineno">209</span><span class="line"><span class="comment">  //.</span></span>
<a id="line210"></a><span class="lineno">210</span><span class="line"><span class="comment">  //. - `:` base-specifier-list</span></span>
<a id="line211"></a><span class="lineno">211</span><span class="line"><span class="comment">  //.</span></span>
<a id="line212"></a><span class="lineno">212</span><span class="line"><span class="comment">  //. base-specifier-list:</span></span>
<a id="line213"></a><span class="lineno">213</span><span class="line"><span class="comment">  //.</span></span>
<a id="line214"></a><span class="lineno">214</span><span class="line"><span class="comment">  //. - base-specifier</span></span>
<a id="line215"></a><span class="lineno">215</span><span class="line"><span class="comment">  //. - base-specifier-list `,` base-specifier</span></span>
<a id="line216"></a><span class="lineno">216</span><span class="line"><span class="comment">  //.</span></span>
<a id="line217"></a><span class="lineno">217</span><span class="line"><span class="comment">  //. base-specifier:</span></span>
<a id="line218"></a><span class="lineno">218</span><span class="line"><span class="comment">  //.</span></span>
<a id="line219"></a><span class="lineno">219</span><span class="line"><span class="comment">  //. - virtual access-specifier [opt] `::` [opt] nested-name-specifier [opt] class-name</span></span>
<a id="line220"></a><span class="lineno">220</span><span class="line"><span class="comment">  //. - access-specifier virtual [opt] `::` [opt] nested-name-specifier [opt] class-name</span></span>
<a id="line221"></a><span class="lineno">221</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::base_clause(PTree::Node*&amp;)">base_clause</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::class_body(PTree::ClassBody*&amp;)">class_body</a>(<a href="../../Scopes/Synopsis/PTree/ClassBody.html" title="class Synopsis::PTree::ClassBody">PTree::ClassBody</a> *&amp;);</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::class_member(PTree::Node*&amp;)">class_member</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::access_decl(PTree::Node*&amp;)">access_decl</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::user_access_spec(PTree::Node*&amp;)">user_access_spec</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">  </span>
<a id="line227"></a><span class="lineno">227</span><span class="line">  <span class="comment">//. expression:</span></span>
<a id="line228"></a><span class="lineno">228</span><span class="line"><span class="comment">  //.</span></span>
<a id="line229"></a><span class="lineno">229</span><span class="line"><span class="comment">  //. - assignment-expression</span></span>
<a id="line230"></a><span class="lineno">230</span><span class="line"><span class="comment">  //. - expression `,` assignment-expression</span></span>
<a id="line231"></a><span class="lineno">231</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::expression(PTree::Node*&amp;)">expression</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line232"></a><span class="lineno">232</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">  <span class="comment">//. assignment-expression:</span></span>
<a id="line234"></a><span class="lineno">234</span><span class="line"><span class="comment">  //.</span></span>
<a id="line235"></a><span class="lineno">235</span><span class="line"><span class="comment">  //. - conditional-expression</span></span>
<a id="line236"></a><span class="lineno">236</span><span class="line"><span class="comment">  //. - logical-or-expression assignment-operator assignment-expression</span></span>
<a id="line237"></a><span class="lineno">237</span><span class="line"><span class="comment">  //. - throw-expression</span></span>
<a id="line238"></a><span class="lineno">238</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::assign_expr(PTree::Node*&amp;)">assign_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line239"></a><span class="lineno">239</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">  <span class="comment">//. conditional-expression:</span></span>
<a id="line241"></a><span class="lineno">241</span><span class="line"><span class="comment">  //.</span></span>
<a id="line242"></a><span class="lineno">242</span><span class="line"><span class="comment">  //. - logical-or-expression</span></span>
<a id="line243"></a><span class="lineno">243</span><span class="line"><span class="comment">  //. - logical-or-expression `?` expression `:` assignment-expression</span></span>
<a id="line244"></a><span class="lineno">244</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::conditional_expr(PTree::Node*&amp;)">conditional_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line245"></a><span class="lineno">245</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">  <span class="comment">//. logical-or-expression:</span></span>
<a id="line247"></a><span class="lineno">247</span><span class="line"><span class="comment">  //.</span></span>
<a id="line248"></a><span class="lineno">248</span><span class="line"><span class="comment">  //. - logical-and-expression</span></span>
<a id="line249"></a><span class="lineno">249</span><span class="line"><span class="comment">  //. - logical-or-expression `||` logical-and-expression</span></span>
<a id="line250"></a><span class="lineno">250</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::logical_or_expr(PTree::Node*&amp;)">logical_or_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line251"></a><span class="lineno">251</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">  <span class="comment">//. logical-and-expression:</span></span>
<a id="line253"></a><span class="lineno">253</span><span class="line"><span class="comment">  //.</span></span>
<a id="line254"></a><span class="lineno">254</span><span class="line"><span class="comment">  //. - inclusive-or-expression</span></span>
<a id="line255"></a><span class="lineno">255</span><span class="line"><span class="comment">  //. - logical-and-expr `&amp;&amp;` inclusive-or-expression</span></span>
<a id="line256"></a><span class="lineno">256</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::logical_and_expr(PTree::Node*&amp;)">logical_and_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line257"></a><span class="lineno">257</span>
<a id="line258"></a><span class="lineno">258</span><span class="line">  <span class="comment">//. inclusive-or-expression:</span></span>
<a id="line259"></a><span class="lineno">259</span><span class="line"><span class="comment">  //.</span></span>
<a id="line260"></a><span class="lineno">260</span><span class="line"><span class="comment">  //. - exclusive-or-expression</span></span>
<a id="line261"></a><span class="lineno">261</span><span class="line"><span class="comment">  //. - inclusive-or-expression `|` exclusive-or-expression</span></span>
<a id="line262"></a><span class="lineno">262</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::inclusive_or_expr(PTree::Node*&amp;)">inclusive_or_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line263"></a><span class="lineno">263</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">  <span class="comment">//. exclusive-or-expression:</span></span>
<a id="line265"></a><span class="lineno">265</span><span class="line"><span class="comment">  //.</span></span>
<a id="line266"></a><span class="lineno">266</span><span class="line"><span class="comment">  //. - and-expression</span></span>
<a id="line267"></a><span class="lineno">267</span><span class="line"><span class="comment">  //. - exclusive-or-expression `^` and-expression</span></span>
<a id="line268"></a><span class="lineno">268</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::exclusive_or_expr(PTree::Node*&amp;)">exclusive_or_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line269"></a><span class="lineno">269</span>
<a id="line270"></a><span class="lineno">270</span><span class="line">  <span class="comment">//. and-expression:</span></span>
<a id="line271"></a><span class="lineno">271</span><span class="line"><span class="comment">  //.</span></span>
<a id="line272"></a><span class="lineno">272</span><span class="line"><span class="comment">  //. - equality-expression</span></span>
<a id="line273"></a><span class="lineno">273</span><span class="line"><span class="comment">  //. - and-expression `&amp;` equality-expression</span></span>
<a id="line274"></a><span class="lineno">274</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::and_expr(PTree::Node*&amp;)">and_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line275"></a><span class="lineno">275</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">  <span class="comment">//. equality-expression:</span></span>
<a id="line277"></a><span class="lineno">277</span><span class="line"><span class="comment">  //.</span></span>
<a id="line278"></a><span class="lineno">278</span><span class="line"><span class="comment">  //. - relational-expression</span></span>
<a id="line279"></a><span class="lineno">279</span><span class="line"><span class="comment">  //. - equality-expression `==` relational-expression</span></span>
<a id="line280"></a><span class="lineno">280</span><span class="line"><span class="comment">  //. - equality-expression `!=` relational-expression</span></span>
<a id="line281"></a><span class="lineno">281</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::equality_expr(PTree::Node*&amp;)">equality_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line282"></a><span class="lineno">282</span>
<a id="line283"></a><span class="lineno">283</span><span class="line">  <span class="comment">//. relational-expression:</span></span>
<a id="line284"></a><span class="lineno">284</span><span class="line"><span class="comment">  //.</span></span>
<a id="line285"></a><span class="lineno">285</span><span class="line"><span class="comment">  //. - shift-expression</span></span>
<a id="line286"></a><span class="lineno">286</span><span class="line"><span class="comment">  //. - relational-expression `&lt;` shift-expression</span></span>
<a id="line287"></a><span class="lineno">287</span><span class="line"><span class="comment">  //. - relational-expression `&gt;` shift-expression</span></span>
<a id="line288"></a><span class="lineno">288</span><span class="line"><span class="comment">  //. - relational-expression `&lt;=` shift-expression</span></span>
<a id="line289"></a><span class="lineno">289</span><span class="line"><span class="comment">  //. - relational-expression `&gt;=` shift-expression</span></span>
<a id="line290"></a><span class="lineno">290</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::relational_expr(PTree::Node*&amp;)">relational_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line291"></a><span class="lineno">291</span>
<a id="line292"></a><span class="lineno">292</span><span class="line">  <span class="comment">//. shift-expression:</span></span>
<a id="line293"></a><span class="lineno">293</span><span class="line"><span class="comment">  //.</span></span>
<a id="line294"></a><span class="lineno">294</span><span class="line"><span class="comment">  //. - additive-expression</span></span>
<a id="line295"></a><span class="lineno">295</span><span class="line"><span class="comment">  //. - shift-expression `&lt;&lt;` additive-expression</span></span>
<a id="line296"></a><span class="lineno">296</span><span class="line"><span class="comment">  //. - shift-expression `&gt;&gt;` additive-expression</span></span>
<a id="line297"></a><span class="lineno">297</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::shift_expr(PTree::Node*&amp;)">shift_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line298"></a><span class="lineno">298</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">  <span class="comment">//. additive-expression:</span></span>
<a id="line300"></a><span class="lineno">300</span><span class="line"><span class="comment">  //.</span></span>
<a id="line301"></a><span class="lineno">301</span><span class="line"><span class="comment">  //. - multiplicative-expression</span></span>
<a id="line302"></a><span class="lineno">302</span><span class="line"><span class="comment">  //. - additive-expression `+` multiplicative-expression</span></span>
<a id="line303"></a><span class="lineno">303</span><span class="line"><span class="comment">  //. - additive-expression `-` multiplicative-expression</span></span>
<a id="line304"></a><span class="lineno">304</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::additive_expr(PTree::Node*&amp;)">additive_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line305"></a><span class="lineno">305</span>
<a id="line306"></a><span class="lineno">306</span><span class="line">  <span class="comment">//. multiplicative-expression:</span></span>
<a id="line307"></a><span class="lineno">307</span><span class="line"><span class="comment">  //.</span></span>
<a id="line308"></a><span class="lineno">308</span><span class="line"><span class="comment">  //. - pm-expression</span></span>
<a id="line309"></a><span class="lineno">309</span><span class="line"><span class="comment">  //. - multiplicative-expression `*` pm-expression</span></span>
<a id="line310"></a><span class="lineno">310</span><span class="line"><span class="comment">  //. - multiplicative-expression `/` pm-expression</span></span>
<a id="line311"></a><span class="lineno">311</span><span class="line"><span class="comment">  //. - multiplicative-expression `%` pm-expression</span></span>
<a id="line312"></a><span class="lineno">312</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::multiplicative_expr(PTree::Node*&amp;)">multiplicative_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line313"></a><span class="lineno">313</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">  <span class="comment">//. pm-expression:</span></span>
<a id="line315"></a><span class="lineno">315</span><span class="line"><span class="comment">  //.</span></span>
<a id="line316"></a><span class="lineno">316</span><span class="line"><span class="comment">  //. - cast-expression</span></span>
<a id="line317"></a><span class="lineno">317</span><span class="line"><span class="comment">  //. - pm-expression `.*` cast-expression</span></span>
<a id="line318"></a><span class="lineno">318</span><span class="line"><span class="comment">  //. - pm-expression `-&gt;*` cast-expression</span></span>
<a id="line319"></a><span class="lineno">319</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::pm_expr(PTree::Node*&amp;)">pm_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line320"></a><span class="lineno">320</span>
<a id="line321"></a><span class="lineno">321</span><span class="line">  <span class="comment">//. cast-expression:</span></span>
<a id="line322"></a><span class="lineno">322</span><span class="line"><span class="comment">  //.</span></span>
<a id="line323"></a><span class="lineno">323</span><span class="line"><span class="comment">  //. - unary-expression</span></span>
<a id="line324"></a><span class="lineno">324</span><span class="line"><span class="comment">  //. - `(` type-id `)` cast-expression</span></span>
<a id="line325"></a><span class="lineno">325</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::cast_expr(PTree::Node*&amp;)">cast_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line326"></a><span class="lineno">326</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">  <span class="comment">//. type-id:</span></span>
<a id="line328"></a><span class="lineno">328</span><span class="line"><span class="comment">  //.</span></span>
<a id="line329"></a><span class="lineno">329</span><span class="line"><span class="comment">  //. - type-specifier-seq abstract-declarator [opt]</span></span>
<a id="line330"></a><span class="lineno">330</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::type_id(PTree::Node*&amp;)">type_id</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::type_id(PTree::Node*&amp;,PTree::Encoding&amp;)">type_id</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line332"></a><span class="lineno">332</span>
<a id="line333"></a><span class="lineno">333</span><span class="line">  <span class="comment">//. unary-expression:</span></span>
<a id="line334"></a><span class="lineno">334</span><span class="line"><span class="comment">  //.</span></span>
<a id="line335"></a><span class="lineno">335</span><span class="line"><span class="comment">  //. - postfix-expression</span></span>
<a id="line336"></a><span class="lineno">336</span><span class="line"><span class="comment">  //. - `++` cast-expression</span></span>
<a id="line337"></a><span class="lineno">337</span><span class="line"><span class="comment">  //. - `--` cast-expression</span></span>
<a id="line338"></a><span class="lineno">338</span><span class="line"><span class="comment">  //. - unary-operator cast-expression</span></span>
<a id="line339"></a><span class="lineno">339</span><span class="line"><span class="comment">  //. - `sizeof` unary-expression</span></span>
<a id="line340"></a><span class="lineno">340</span><span class="line"><span class="comment">  //. - `sizeof` `(` unary-expression `)`</span></span>
<a id="line341"></a><span class="lineno">341</span><span class="line"><span class="comment">  //. - new-expression</span></span>
<a id="line342"></a><span class="lineno">342</span><span class="line"><span class="comment">  //. - delete-expression</span></span>
<a id="line343"></a><span class="lineno">343</span><span class="line"><span class="comment">  //.</span></span>
<a id="line344"></a><span class="lineno">344</span><span class="line"><span class="comment">  //. unary-operator:</span></span>
<a id="line345"></a><span class="lineno">345</span><span class="line"><span class="comment">  //.</span></span>
<a id="line346"></a><span class="lineno">346</span><span class="line"><span class="comment">  //. - `*`</span></span>
<a id="line347"></a><span class="lineno">347</span><span class="line"><span class="comment">  //. - `&amp;`</span></span>
<a id="line348"></a><span class="lineno">348</span><span class="line"><span class="comment">  //. - `+`</span></span>
<a id="line349"></a><span class="lineno">349</span><span class="line"><span class="comment">  //. - `-`</span></span>
<a id="line350"></a><span class="lineno">350</span><span class="line"><span class="comment">  //. - `!`</span></span>
<a id="line351"></a><span class="lineno">351</span><span class="line"><span class="comment">  //. - `~`</span></span>
<a id="line352"></a><span class="lineno">352</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::unary_expr(PTree::Node*&amp;)">unary_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line353"></a><span class="lineno">353</span>
<a id="line354"></a><span class="lineno">354</span><span class="line">  <span class="comment">//. throw-expression:</span></span>
<a id="line355"></a><span class="lineno">355</span><span class="line"><span class="comment">  //.</span></span>
<a id="line356"></a><span class="lineno">356</span><span class="line"><span class="comment">  //. - `throw` assignment-expression</span></span>
<a id="line357"></a><span class="lineno">357</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::throw_expr(PTree::Node*&amp;)">throw_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line358"></a><span class="lineno">358</span>
<a id="line359"></a><span class="lineno">359</span><span class="line">  <span class="comment">//. sizeof-expression:</span></span>
<a id="line360"></a><span class="lineno">360</span><span class="line"><span class="comment">  //.</span></span>
<a id="line361"></a><span class="lineno">361</span><span class="line"><span class="comment">  //. - `sizeof` unary-expression</span></span>
<a id="line362"></a><span class="lineno">362</span><span class="line"><span class="comment">  //. - `sizeof` `(` type-id `)`</span></span>
<a id="line363"></a><span class="lineno">363</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::sizeof_expr(PTree::Node*&amp;)">sizeof_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line364"></a><span class="lineno">364</span>
<a id="line365"></a><span class="lineno">365</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::offsetof_expr(PTree::Node*&amp;)">offsetof_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line366"></a><span class="lineno">366</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">  <span class="comment">//. typeid-expression:</span></span>
<a id="line368"></a><span class="lineno">368</span><span class="line"><span class="comment">  //.</span></span>
<a id="line369"></a><span class="lineno">369</span><span class="line"><span class="comment">  //. - typeid `(` type-id `)`</span></span>
<a id="line370"></a><span class="lineno">370</span><span class="line"><span class="comment">  //. - typeid `(` expression `)`</span></span>
<a id="line371"></a><span class="lineno">371</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::typeid_expr(PTree::Node*&amp;)">typeid_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line372"></a><span class="lineno">372</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::is_allocate_expr(Token::Type)">is_allocate_expr</a>(<a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a>);</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::allocate_expr(PTree::Node*&amp;)">allocate_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::userdef_keyword(PTree::Node*&amp;)">userdef_keyword</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::allocate_type(PTree::Node*&amp;)">allocate_type</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::new_declarator(PTree::Declarator*&amp;,PTree::Encoding&amp;)">new_declarator</a>(<a href="../../Scopes/Synopsis/PTree/Declarator.html" title="class Synopsis::PTree::Declarator">PTree::Declarator</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line377"></a><span class="lineno">377</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::allocate_initializer(PTree::Node*&amp;)">allocate_initializer</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line378"></a><span class="lineno">378</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::postfix_expr(PTree::Node*&amp;)">postfix_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::primary_expr(PTree::Node*&amp;)">primary_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line380"></a><span class="lineno">380</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::typeof_expr(PTree::Node*&amp;)">typeof_expr</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line381"></a><span class="lineno">381</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::userdef_statement(PTree::Node*&amp;)">userdef_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line382"></a><span class="lineno">382</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::var_name(PTree::Node*&amp;)">var_name</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line383"></a><span class="lineno">383</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::var_name_core(PTree::Node*&amp;,PTree::Encoding&amp;)">var_name_core</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;);</span>
<a id="line384"></a><span class="lineno">384</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#is_template_args_l_r" title="member function Synopsis::Parser::is_template_args()">is_template_args</a>();</span>
<a id="line385"></a><span class="lineno">385</span><span class="line">  </span>
<a id="line386"></a><span class="lineno">386</span><span class="line">  <span class="comment">//. function-body:</span></span>
<a id="line387"></a><span class="lineno">387</span><span class="line"><span class="comment">  //.</span></span>
<a id="line388"></a><span class="lineno">388</span><span class="line"><span class="comment">  //. - compound-statement</span></span>
<a id="line389"></a><span class="lineno">389</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::function_body(PTree::Block*&amp;)">function_body</a>(<a href="../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">PTree::Block</a> *&amp;);</span>
<a id="line390"></a><span class="lineno">390</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">  <span class="comment">//. compound-statement:</span></span>
<a id="line392"></a><span class="lineno">392</span><span class="line"><span class="comment">  //.</span></span>
<a id="line393"></a><span class="lineno">393</span><span class="line"><span class="comment">  //. - `{` statement [opt] `}`</span></span>
<a id="line394"></a><span class="lineno">394</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::compound_statement(PTree::Block*&amp;,bool)">compound_statement</a>(<a href="../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">PTree::Block</a> *&amp;, <span class="keyword">bool</span> create_scope = false);</span>
<a id="line395"></a><span class="lineno">395</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::statement(PTree::Node*&amp;)">statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line396"></a><span class="lineno">396</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">  <span class="comment">//. if-statement:</span></span>
<a id="line398"></a><span class="lineno">398</span><span class="line"><span class="comment">  //.</span></span>
<a id="line399"></a><span class="lineno">399</span><span class="line"><span class="comment">  //. - `if` `(` condition `)` statement</span></span>
<a id="line400"></a><span class="lineno">400</span><span class="line"><span class="comment">  //. - `if` `(` condition `)` statement else statement</span></span>
<a id="line401"></a><span class="lineno">401</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::if_statement(PTree::Node*&amp;)">if_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line402"></a><span class="lineno">402</span>
<a id="line403"></a><span class="lineno">403</span><span class="line">  <span class="comment">//. switch-statement:</span></span>
<a id="line404"></a><span class="lineno">404</span><span class="line"><span class="comment">  //.</span></span>
<a id="line405"></a><span class="lineno">405</span><span class="line"><span class="comment">  //. - `switch` `(` condition `)` statement</span></span>
<a id="line406"></a><span class="lineno">406</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::switch_statement(PTree::Node*&amp;)">switch_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line407"></a><span class="lineno">407</span>
<a id="line408"></a><span class="lineno">408</span><span class="line">  <span class="comment">//. while-statement:</span></span>
<a id="line409"></a><span class="lineno">409</span><span class="line"><span class="comment">  //.</span></span>
<a id="line410"></a><span class="lineno">410</span><span class="line"><span class="comment">  //. - `while` `(` condition `)` statement</span></span>
<a id="line411"></a><span class="lineno">411</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::while_statement(PTree::Node*&amp;)">while_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line412"></a><span class="lineno">412</span>
<a id="line413"></a><span class="lineno">413</span><span class="line">  <span class="comment">//. do-statement:</span></span>
<a id="line414"></a><span class="lineno">414</span><span class="line"><span class="comment">  //.</span></span>
<a id="line415"></a><span class="lineno">415</span><span class="line"><span class="comment">  //. - `do` statement `while` `(` condition `)` `;`</span></span>
<a id="line416"></a><span class="lineno">416</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::do_statement(PTree::Node*&amp;)">do_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line417"></a><span class="lineno">417</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::for_statement(PTree::Node*&amp;)">for_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line418"></a><span class="lineno">418</span>
<a id="line419"></a><span class="lineno">419</span><span class="line">  <span class="comment">//. try-block:</span></span>
<a id="line420"></a><span class="lineno">420</span><span class="line"><span class="comment">  //.</span></span>
<a id="line421"></a><span class="lineno">421</span><span class="line"><span class="comment">  //. - `try` compound-statement handler-seq</span></span>
<a id="line422"></a><span class="lineno">422</span><span class="line"><span class="comment">  //.</span></span>
<a id="line423"></a><span class="lineno">423</span><span class="line"><span class="comment">  //. handler-seq:</span></span>
<a id="line424"></a><span class="lineno">424</span><span class="line"><span class="comment">  //.</span></span>
<a id="line425"></a><span class="lineno">425</span><span class="line"><span class="comment">  //. - handler handler-seq [opt]</span></span>
<a id="line426"></a><span class="lineno">426</span><span class="line"><span class="comment">  //.</span></span>
<a id="line427"></a><span class="lineno">427</span><span class="line"><span class="comment">  //. handler:</span></span>
<a id="line428"></a><span class="lineno">428</span><span class="line"><span class="comment">  //.</span></span>
<a id="line429"></a><span class="lineno">429</span><span class="line"><span class="comment">  //. - `catch` `(` exception-declaration `)` compound-statement</span></span>
<a id="line430"></a><span class="lineno">430</span><span class="line"><span class="comment">  //.</span></span>
<a id="line431"></a><span class="lineno">431</span><span class="line"><span class="comment">  //. exception-declaration:</span></span>
<a id="line432"></a><span class="lineno">432</span><span class="line"><span class="comment">  //.</span></span>
<a id="line433"></a><span class="lineno">433</span><span class="line"><span class="comment">  //. - type-specifier-seq declarator</span></span>
<a id="line434"></a><span class="lineno">434</span><span class="line"><span class="comment">  //. - type-specifier-seq abstract-declarator</span></span>
<a id="line435"></a><span class="lineno">435</span><span class="line"><span class="comment">  //. - type-specifier-seq</span></span>
<a id="line436"></a><span class="lineno">436</span><span class="line"><span class="comment">  //. - `...`</span></span>
<a id="line437"></a><span class="lineno">437</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::try_block(PTree::Node*&amp;)">try_block</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line438"></a><span class="lineno">438</span><span class="line">  </span>
<a id="line439"></a><span class="lineno">439</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::expr_statement(PTree::Node*&amp;)">expr_statement</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *&amp;);</span>
<a id="line440"></a><span class="lineno">440</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::declaration_statement(PTree::Declaration*&amp;)">declaration_statement</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;);</span>
<a id="line441"></a><span class="lineno">441</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::integral_decl_statement(PTree::Declaration*&amp;,PTree::Encoding&amp;,PTree::Node*,PTree::Node*,PTree::Node*)">integral_decl_statement</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *);</span>
<a id="line442"></a><span class="lineno">442</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::Parser::other_decl_statement(PTree::Declaration*&amp;,PTree::Encoding&amp;,PTree::Node*,PTree::Node*)">other_decl_statement</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration</a> *&amp;, <a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a>&amp;, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *);</span>
<a id="line443"></a><span class="lineno">443</span>
<a id="line444"></a><span class="lineno">444</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#maybe_typename_or_class_template_lToken_A_r" title="member function Synopsis::Parser::maybe_typename_or_class_template(Token&amp;)">maybe_typename_or_class_template</a>(<a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a>&amp;);</span>
<a id="line445"></a><span class="lineno">445</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::Parser::skip_to(Token::Type)">skip_to</a>(<a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Token::Type</a> token);</span>
<a id="line446"></a><span class="lineno">446</span><span class="line">  </span>
<a id="line447"></a><span class="lineno">447</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line448"></a><span class="lineno">448</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Parser.html#more_var_name_l_r" title="member function Synopsis::Parser::more_var_name()">more_var_name</a>();</span>
<a id="line449"></a><span class="lineno">449</span>
<a id="line450"></a><span class="lineno">450</span><span class="line">  <a href="../../Scopes/Synopsis/Lexer.html" title="class Synopsis::Lexer">Lexer</a> &amp;         <a href="../../Scopes/Synopsis/Parser.html#my_lexer" title="data member Synopsis::Parser::my_lexer">my_lexer</a>;</span>
<a id="line451"></a><span class="lineno">451</span><span class="line">  <span class="keyword">int</span>             <a href="../../Scopes/Synopsis/Parser.html#my_ruleset" title="data member Synopsis::Parser::my_ruleset">my_ruleset</a>;</span>
<a id="line452"></a><span class="lineno">452</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolFactory.html" title="class Synopsis::SymbolFactory">SymbolFactory</a> &amp; <a href="../../Scopes/Synopsis/Parser.html#my_symbols" title="data member Synopsis::Parser::my_symbols">my_symbols</a>;</span>
<a id="line453"></a><span class="lineno">453</span><span class="line">  <span class="comment">//. Record whether the current scope is valid.</span></span>
<a id="line454"></a><span class="lineno">454</span><span class="line"><span class="comment">  //. This allows the parser to continue parsing even after</span></span>
<a id="line455"></a><span class="lineno">455</span><span class="line"><span class="comment">  //. it was unable to enter a scope (such as in a function definition</span></span>
<a id="line456"></a><span class="lineno">456</span><span class="line"><span class="comment">  //. with a qualified name that wasn't declared before).</span></span>
<a id="line457"></a><span class="lineno">457</span><span class="line">  <span class="keyword">bool</span>            <a href="../../Scopes/Synopsis/Parser.html#my_scope_is_valid" title="data member Synopsis::Parser::my_scope_is_valid">my_scope_is_valid</a>;</span>
<a id="line458"></a><span class="lineno">458</span><span class="line">  <a href="../../Scopes/Synopsis/Parser.html#ErrorList" title="typedef Synopsis::Parser::ErrorList">ErrorList</a>       <a href="../../Scopes/Synopsis/Parser.html#my_errors" title="data member Synopsis::Parser::my_errors">my_errors</a>;</span>
<a id="line459"></a><span class="lineno">459</span><span class="line">  <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node</a> *   <a href="../../Scopes/Synopsis/Parser.html#my_comments" title="data member Synopsis::Parser::my_comments">my_comments</a>;</span>
<a id="line460"></a><span class="lineno">460</span><span class="line">  <span class="comment">//. If true, `&gt;` is interpreted as ther greater-than operator.</span></span>
<a id="line461"></a><span class="lineno">461</span><span class="line"><span class="comment">  //. If false, it marks the end of a template-id or template-parameter-list.</span></span>
<a id="line462"></a><span class="lineno">462</span><span class="line">  <span class="keyword">bool</span>            <a href="../../Scopes/Synopsis/Parser.html#my_gt_is_operator" title="data member Synopsis::Parser::my_gt_is_operator">my_gt_is_operator</a>;</span>
<a id="line463"></a><span class="lineno">463</span><span class="line">  <span class="keyword">bool</span>            <a href="../../Scopes/Synopsis/Parser.html#my_in_template_decl" title="data member Synopsis::Parser::my_in_template_decl">my_in_template_decl</a>;</span>
<a id="line464"></a><span class="lineno">464</span><span class="line">};</span>
<a id="line465"></a><span class="lineno">465</span>
<a id="line466"></a><span class="lineno">466</span><span class="line">}</span>
<a id="line467"></a><span class="lineno">467</span>
<a id="line468"></a><span class="lineno">468</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:04 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
